/**
 * Copyright: Copyright (c) 2008 Jacob Carlborg. All rights reserved.
 * Authors: Jacob Carlborg
 * Version: Initial created: Nov 18, 2008
 * License: $(LINK2 http://opensource.org/licenses/bsd-license.php, BSD Style)
 * 
 */
module dwt.internal.objc.cocoa.Cocoa;

import tango.stdc.config;
import bindings = dwt.internal.objc.cocoa.bindings;
import dwt.internal.objc.runtime;

extern (C):

// *.h
extern
{
    id NSAccessibilityButtonRole;
    id NSAccessibilityCheckBoxRole;
    id NSAccessibilityChildrenAttribute;
    id NSAccessibilityColumnRole;
    id NSAccessibilityComboBoxRole;
    id NSAccessibilityConfirmAction;
    id NSAccessibilityContentsAttribute;
    id NSAccessibilityDescriptionAttribute;
    id NSAccessibilityDialogSubrole;
    id NSAccessibilityEnabledAttribute;
    id NSAccessibilityExpandedAttribute;
    id NSAccessibilityFloatingWindowSubrole;
    id NSAccessibilityFocusedAttribute;
    id NSAccessibilityFocusedUIElementChangedNotification;
    id NSAccessibilityGridRole;
    id NSAccessibilityGroupRole;
    id NSAccessibilityHelpAttribute;
    id NSAccessibilityHelpTagRole;
    id NSAccessibilityHorizontalOrientationValue;
    id NSAccessibilityHorizontalScrollBarAttribute;
    id NSAccessibilityImageRole;
    id NSAccessibilityIncrementorRole;
    id NSAccessibilityInsertionPointLineNumberAttribute;
    id NSAccessibilityLabelValueAttribute;
    id NSAccessibilityLineForIndexParameterizedAttribute;
    id NSAccessibilityLinkRole;
    id NSAccessibilityLinkTextAttribute;
    id NSAccessibilityListRole;
    id NSAccessibilityMaxValueAttribute;
    id NSAccessibilityMenuBarRole;
    id NSAccessibilityMenuButtonRole;
    id NSAccessibilityMenuItemRole;
    id NSAccessibilityMenuRole;
    id NSAccessibilityMinValueAttribute;
    id NSAccessibilityNextContentsAttribute;
    id NSAccessibilityNumberOfCharactersAttribute;
    id NSAccessibilityOrientationAttribute;
    id NSAccessibilityOutlineRole;
    id NSAccessibilityOutlineRowSubrole;
    id NSAccessibilityParentAttribute;
    id NSAccessibilityPopUpButtonRole;
    id NSAccessibilityPositionAttribute;
    id NSAccessibilityPressAction;
    id NSAccessibilityPreviousContentsAttribute;
    id NSAccessibilityProgressIndicatorRole;
    id NSAccessibilityRTFForRangeParameterizedAttribute;
    id NSAccessibilityRadioButtonRole;
    id NSAccessibilityRadioGroupRole;
    id NSAccessibilityRangeForIndexParameterizedAttribute;
    id NSAccessibilityRangeForLineParameterizedAttribute;
    id NSAccessibilityRangeForPositionParameterizedAttribute;
    id NSAccessibilityRoleAttribute;
    id NSAccessibilityRoleDescriptionAttribute;
    id NSAccessibilityRowRole;
    id NSAccessibilityScrollAreaRole;
    id NSAccessibilityScrollBarRole;
    id NSAccessibilitySelectedAttribute;
    id NSAccessibilitySelectedChildrenAttribute;
    id NSAccessibilitySelectedChildrenChangedNotification;
    id NSAccessibilitySelectedTextAttribute;
    id NSAccessibilitySelectedTextChangedNotification;
    id NSAccessibilitySelectedTextRangeAttribute;
    id NSAccessibilitySelectedTextRangesAttribute;
    id NSAccessibilitySizeAttribute;
    id NSAccessibilitySliderRole;
    id NSAccessibilitySortButtonRole;
    id NSAccessibilitySplitterRole;
    id NSAccessibilityStandardWindowSubrole;
    id NSAccessibilityStaticTextRole;
    id NSAccessibilityStringForRangeParameterizedAttribute;
    id NSAccessibilityStyleRangeForIndexParameterizedAttribute;
    id NSAccessibilitySubroleAttribute;
    id NSAccessibilitySystemDialogSubrole;
    id NSAccessibilityTabGroupRole;
    id NSAccessibilityTableRole;
    id NSAccessibilityTableRowSubrole;
    id NSAccessibilityTabsAttribute;
    id NSAccessibilityTextAreaRole;
    id NSAccessibilityTextFieldRole;
    id NSAccessibilityTextLinkSubrole;
    id NSAccessibilityTitleAttribute;
    id NSAccessibilityTitleUIElementAttribute;
    id NSAccessibilityToolbarRole;
    id NSAccessibilityTopLevelUIElementAttribute;
    id NSAccessibilityUnknownRole;
    id NSAccessibilityUnknownSubrole;
    id NSAccessibilityValueAttribute;
    id NSAccessibilityValueChangedNotification;
    id NSAccessibilityValueDescriptionAttribute;
    id NSAccessibilityValueIndicatorRole;
    id NSAccessibilityVerticalOrientationValue;
    id NSAccessibilityVerticalScrollBarAttribute;
    id NSAccessibilityVisibleCharacterRangeAttribute;
    id NSAccessibilityVisibleChildrenAttribute;
    id NSAccessibilityWindowAttribute;
    id NSAccessibilityWindowRole;
    id NSBackgroundColorAttributeName;
    id NSBaselineOffsetAttributeName;
    id NSCalibratedRGBColorSpace;
    id NSDeviceRGBColorSpace;
    id NSDeviceResolution;
    id NSDragPboard;
    id NSFilenamesPboardType;
    id NSFontAttributeName;
    id NSForegroundColorAttributeName;
    id NSHTMLPboardType;
    id NSLinkAttributeName;
    id NSParagraphStyleAttributeName;
    id NSPrintAllPages;
    id NSPrintCopies;
    id NSPrintFirstPage;
    id NSPrintJobDisposition;
    id NSPrintLastPage;
    id NSPrintMustCollate;
    id NSPrintPreviewJob;
    id NSPrintSaveJob;
    id NSPrintSavePath;
    id NSPrintSpoolJob;
    id NSRTFPboardType;
    id NSStrikethroughColorAttributeName;
    id NSStrikethroughStyleAttributeName;
    id NSStringPboardType;
    id NSTIFFPboardType;
    id NSURLPboardType;
    id NSUnderlineColorAttributeName;
    id NSUnderlineStyleAttributeName;
    id NSDefaultRunLoopMode;
    id NSErrorFailingURLStringKey;
}



//NSAccessibility.h
alias bindings.NSAccessibilityActionDescription NSAccessibilityActionDescription;
alias bindings.NSAccessibilityPostNotification NSAccessibilityPostNotification;
alias bindings.NSAccessibilityRaiseBadArgumentException NSAccessibilityRaiseBadArgumentException;
alias bindings.NSAccessibilityRoleDescription NSAccessibilityRoleDescription;
alias bindings.NSAccessibilityRoleDescriptionForUIElement NSAccessibilityRoleDescriptionForUIElement;
alias bindings.NSAccessibilityUnignoredAncestor NSAccessibilityUnignoredAncestor;
alias bindings.NSAccessibilityUnignoredChildren NSAccessibilityUnignoredChildren;
alias bindings.NSAccessibilityUnignoredChildrenForOnlyChild NSAccessibilityUnignoredChildrenForOnlyChild;
alias bindings.NSAccessibilityUnignoredDescendant NSAccessibilityUnignoredDescendant;



// NSDragging.h
enum NSDragOperation : uint
{
    NSDragOperationNone = 0,
    NSDragOperationCopy = 1,
    NSDragOperationLink = 2,
    NSDragOperationGeneric = 4,
    NSDragOperationPrivate = 8,
    NSDragOperationAll_Obsolete = 15,
    NSDragOperationMove = 16,
    NSDragOperationDelete = 32,
    NSDragOperationEvery = uint.max // UINT_MAX
}



// NSGraphics.h
alias int NSWindowDepth;

alias bindings.NSBeep NSBeep;
alias bindings.NSBitsPerPixelFromDepth NSBitsPerPixelFromDepth;

enum NSCompositingOperation
{
    NSCompositeClear = 0,
    NSCompositeCopy = 1,
    NSCompositeSourceOver = 2,
    NSCompositeSourceIn = 3,
    NSCompositeSourceOut = 4,
    NSCompositeSourceAtop = 5,
    NSCompositeDestinationOver = 6,
    NSCompositeDestinationIn = 7,
    NSCompositeDestinationOut = 8,
    NSCompositeDestinationAtop = 9,
    NSCompositeXOR = 10,
    NSCompositePlusDarker = 11,
    NSCompositeHighlight = 12,
    NSCompositePlusLighter = 13
}

enum NSWindowOrderingMode
{
    NSWindowAbove = 1,
    NSWindowBelow = -1,
    NSWindowOut = 0
}

enum NSFocusRingType
{
    NSFocusRingTypeDefault = 0,
    NSFocusRingTypeNone = 1,
    NSFocusRingTypeExterior = 2
}

enum NSBackingStoreType
{
    NSBackingStoreRetained     = 0,
    NSBackingStoreNonretained  = 1,
    NSBackingStoreBuffered     = 2
}



//NSGeometry.h
alias bindings.NSIntersectionRect NSIntersectionRect;



// NSHFSFileTypes.h
alias bindings.NSFileTypeForHFSTypeCode NSFileTypeForHFSTypeCode;



//IKPictureTaker.h
alias c_long NSInteger;
alias c_ulong NSUInteger;



// NSObjCRuntime.h
alias bindings.NSGetSizeAndAlignment NSGetSizeAndAlignment;

enum 
{
    NSNotFound = 0x7fffffff
}

// NSPathUtilities.h
enum NSSearchPathDirectory
{
    NSApplicationDirectory = 1,
    NSDemoApplicationDirectory,
    NSDeveloperApplicationDirectory,
    NSAdminApplicationDirectory,
    NSLibraryDirectory,
    NSDeveloperDirectory,
    NSUserDirectory,
    NSDocumentationDirectory,
    NSDocumentDirectory,
    NSCoreServiceDirectory,
    NSDesktopDirectory = 12,
    NSCachesDirectory = 13,
    NSApplicationSupportDirectory = 14,
    NSDownloadsDirectory = 15,
    NSAllApplicationsDirectory = 100,
    NSAllLibrariesDirectory = 101
}

enum NSSearchPathDomainMask
{
    NSUserDomainMask = 1,
    NSLocalDomainMask = 2,
    NSNetworkDomainMask = 4,
    NSSystemDomainMask = 8,
    NSAllDomainsMask = 0x0ffff,
} 
 
alias bindings.NSSearchPathForDirectoriesInDomains NSSearchPathForDirectoriesInDomains;
alias bindings.NSTemporaryDirectory NSTemporaryDirectory;



// NSZone.h
alias void* _NSZone;
alias _NSZone NSZone;